Index: i386/i386/nexus.c
===========================================================================
--- sys/i386/i386/nexus.c	2003/10/30 14:48:07	#10
+++ i386/i386/nexus.c	2003/10/30 14:48:07
@@ -50,6 +50,7 @@
 #include <sys/malloc.h>
 #include <sys/module.h>
 #include <machine/bus.h>
+#include <machine/intr_machdep.h>
 #include <sys/rman.h>
 #include <sys/interrupt.h>
 
@@ -59,10 +60,6 @@
 #include <machine/pmap.h>
 
 #include <machine/resource.h>
-#ifdef APIC_IO
-#include <machine/smp.h>
-#include <machine/mpapic.h>
-#endif
 
 #ifdef DEV_ISA
 #include <isa/isavar.h>
@@ -72,8 +69,6 @@
 #include <i386/isa/isa.h>
 #endif
 #endif
-#include <i386/isa/icu.h>
-#include <i386/isa/intr_machdep.h>
 #include <sys/rtprio.h>
 
 static MALLOC_DEFINE(M_NEXUSDEV, "nexusdev", "Nexus device");
@@ -164,18 +159,11 @@
 	 * multi-ISA-bus systems.  PCI interrupts are routed to the ISA
 	 * component, so in a way, PCI can be a partial child of an ISA bus(!).
 	 * APIC interrupts are global though.
-	 *
-	 * XXX We depend on the AT PIC driver correctly claiming IRQ 2
-	 *     to prevent its reuse elsewhere in the !APIC_IO case.
 	 */
 	irq_rman.rm_start = 0;
 	irq_rman.rm_type = RMAN_ARRAY;
 	irq_rman.rm_descr = "Interrupt request lines";
-#ifdef APIC_IO
-	irq_rman.rm_end = APIC_INTMAPSIZE - 1;
-#else
-	irq_rman.rm_end = 15;
-#endif
+	irq_rman.rm_end = NUM_IO_INTS - 1;
 	if (rman_init(&irq_rman)
 	    || rman_manage_region(&irq_rman,
 				  irq_rman.rm_start, irq_rman.rm_end))
@@ -474,7 +462,7 @@
 	if (error)
 		return (error);
 
-	error = inthand_add(device_get_nameunit(child), irq->r_start,
+	error = intr_add_handler(device_get_nameunit(child), irq->r_start,
 	    ihand, arg, flags, cookiep);
 
 	return (error);
@@ -483,7 +471,7 @@
 static int
 nexus_teardown_intr(device_t dev, device_t child, struct resource *r, void *ih)
 {
-	return (inthand_remove(ih));
+	return (intr_remove_handler(ih));
 }
 
 static int
Index: i386/i386/pmap.c
===========================================================================
--- sys/i386/i386/pmap.c	2003/10/30 14:48:07	#165
+++ i386/i386/pmap.c	2003/10/30 14:48:07
@@ -136,12 +136,9 @@
 #include <machine/cputypes.h>
 #include <machine/md_var.h>
 #include <machine/specialreg.h>
-#if defined(SMP) || defined(APIC_IO)
+#ifdef SMP
 #include <machine/smp.h>
-#include <machine/apic.h>
-#include <machine/segments.h>
-#include <machine/tss.h>
-#endif /* SMP || APIC_IO */
+#endif
 
 #define PMAP_KEEP_PDIRS
 #ifndef PMAP_SHPGPERPROC
@@ -391,16 +388,6 @@
 
 	/* Turn on PG_G on kernel page(s) */
 	pmap_set_pg();
-
-#ifdef SMP
-	if (cpu_apic_address == 0)
-		panic("pmap_bootstrap: no local apic! (non-SMP hardware?)");
-
-	/* local apic is mapped on last page */
-	SMPpt[NPTEPG - 1] = (pt_entry_t)(PG_V | PG_RW | PG_N | pgeflag |
-	    (cpu_apic_address & PG_FRAME));
-#endif
-	invltlb();
 }
 
 /*
@@ -603,11 +590,17 @@
 	u_int cpumask;
 	u_int other_cpus;
 
-	critical_enter();
+	if (smp_started) {
+		if (!(read_eflags() & PSL_I))
+			panic("%s: interrupts disabled", __func__);
+		mtx_lock_spin(&smp_tlb_mtx);
+	} else
+		critical_enter();
 	/*
 	 * We need to disable interrupt preemption but MUST NOT have
 	 * interrupts disabled here.
 	 * XXX we may need to hold schedlock to get a coherent pm_active
+	 * XXX critical sections disable interrupts again
 	 */
 	if (pmap->pm_active == -1 || pmap->pm_active == all_cpus) {
 		invlpg(va);
@@ -620,7 +613,10 @@
 		if (pmap->pm_active & other_cpus)
 			smp_masked_invlpg(pmap->pm_active & other_cpus, va);
 	}
-	critical_exit();
+	if (smp_started)
+		mtx_unlock_spin(&smp_tlb_mtx);
+	else
+		critical_exit();
 }
 
 void
@@ -630,11 +626,17 @@
 	u_int other_cpus;
 	vm_offset_t addr;
 
-	critical_enter();
+	if (smp_started) {
+		if (!(read_eflags() & PSL_I))
+			panic("%s: interrupts disabled", __func__);
+		mtx_lock_spin(&smp_tlb_mtx);
+	} else
+		critical_enter();
 	/*
 	 * We need to disable interrupt preemption but MUST NOT have
 	 * interrupts disabled here.
 	 * XXX we may need to hold schedlock to get a coherent pm_active
+	 * XXX critical sections disable interrupts again
 	 */
 	if (pmap->pm_active == -1 || pmap->pm_active == all_cpus) {
 		for (addr = sva; addr < eva; addr += PAGE_SIZE)
@@ -650,7 +652,10 @@
 			smp_masked_invlpg_range(pmap->pm_active & other_cpus,
 			    sva, eva);
 	}
-	critical_exit();
+	if (smp_started)
+		mtx_unlock_spin(&smp_tlb_mtx);
+	else
+		critical_exit();
 }
 
 void
@@ -659,11 +664,17 @@
 	u_int cpumask;
 	u_int other_cpus;
 
-	critical_enter();
+	if (smp_started) {
+		if (!(read_eflags() & PSL_I))
+			panic("%s: interrupts disabled", __func__);
+		mtx_lock_spin(&smp_tlb_mtx);
+	} else
+		critical_enter();
 	/*
 	 * We need to disable interrupt preemption but MUST NOT have
 	 * interrupts disabled here.
 	 * XXX we may need to hold schedlock to get a coherent pm_active
+	 * XXX critical sections disable interrupts again
 	 */
 	if (pmap->pm_active == -1 || pmap->pm_active == all_cpus) {
 		invltlb();
@@ -676,7 +687,10 @@
 		if (pmap->pm_active & other_cpus)
 			smp_masked_invltlb(pmap->pm_active & other_cpus);
 	}
-	critical_exit();
+	if (smp_started)
+		mtx_unlock_spin(&smp_tlb_mtx);
+	else
+		critical_exit();
 }
 #else /* !SMP */
 /*
@@ -2882,7 +2896,10 @@
 	offset = pa & PAGE_MASK;
 	size = roundup(offset + size, PAGE_SIZE);
 
-	va = kmem_alloc_nofault(kernel_map, size);
+	if (pa < KERNLOAD && pa + size <= KERNLOAD)
+		va = KERNBASE + pa;
+	else
+		va = kmem_alloc_nofault(kernel_map, size);
 	if (!va)
 		panic("pmap_mapdev: Couldn't alloc kernel virtual memory");
 
@@ -2904,6 +2921,8 @@
 {
 	vm_offset_t base, offset, tmpva;
 
+	if (va >= KERNBASE && va + size <= KERNBASE + KERNLOAD)
+		return;
 	base = va & PG_FRAME;
 	offset = va & PAGE_MASK;
 	size = roundup(offset + size, PAGE_SIZE);
Index: i386/i386/support.s
===========================================================================
--- sys/i386/i386/support.s	2003/10/30 14:48:07	#16
+++ i386/i386/support.s	2003/10/30 14:48:07
@@ -37,6 +37,7 @@
 
 #include <machine/asmacros.h>
 #include <machine/cputypes.h>
+#include <machine/intr_machdep.h>
 #include <machine/pmap.h>
 #include <machine/specialreg.h>
 
@@ -62,6 +63,16 @@
 	.byte	0xfe
 	.space	3
 #endif
+	ALIGN_DATA
+	.globl	intrcnt, eintrcnt
+intrcnt:
+	.space	INTRCNT_COUNT * 4
+eintrcnt:
+
+	.globl	intrnames, eintrnames
+intrnames:
+	.space	INTRCNT_COUNT * (MAXCOMLEN + 1)
+eintrnames:
 
 	.text
 
Index: i386/i386/trap.c
===========================================================================
--- sys/i386/i386/trap.c	2003/10/30 14:48:07	#62
+++ i386/i386/trap.c	2003/10/30 14:48:07
@@ -82,6 +82,7 @@
 #include <vm/vm_extern.h>
 
 #include <machine/cpu.h>
+#include <machine/intr_machdep.h>
 #include <machine/md_var.h>
 #include <machine/pcb.h>
 #ifdef SMP
@@ -90,9 +91,6 @@
 #include <machine/tss.h>
 #include <machine/vm86.h>
 
-#include <i386/isa/icu.h>
-#include <i386/isa/intr_machdep.h>
-
 #ifdef POWERFAIL_NMI
 #include <sys/syslog.h>
 #include <machine/clock.h>
@@ -764,7 +762,7 @@
 #ifdef SMP
 	/* two separate prints in case of a trap on an unmapped page */
 	printf("cpuid = %d; ", PCPU_GET(cpuid));
-	printf("lapic.id = %08x\n", lapic.id);
+	printf("apic id = %02x\n", PCPU_GET(apic_id));
 #endif
 	if (type == T_PAGEFLT) {
 		printf("fault virtual address	= 0x%x\n", eva);
@@ -847,7 +845,7 @@
 #ifdef SMP
 	/* two separate prints in case of a trap on an unmapped page */
 	printf("cpuid = %d; ", PCPU_GET(cpuid));
-	printf("lapic.id = %08x\n", lapic.id);
+	printf("apic id = %02x\n", PCPU_GET(apic_id));
 #endif
 	panic("double fault");
 }
Index: i386/include/apic.h
===========================================================================
--- sys/i386/include/apic.h	2003/10/30 14:48:07	#8
+++ i386/include/apic.h	2003/10/30 14:48:07
@@ -25,8 +25,8 @@
  * $FreeBSD: src/sys/i386/include/apic.h,v 1.24 2003/09/10 01:11:58 jhb Exp $
  */
 
-#ifndef _MACHINE_APIC_H_
-#define _MACHINE_APIC_H_
+#ifndef _MACHINE_APICREG_H_
+#define _MACHINE_APICREG_H_
 
 /*
  * Local && I/O APIC definitions.
@@ -221,11 +221,29 @@
 /* default physical locations of LOCAL (CPU) APICs */
 #define DEFAULT_APIC_BASE	0xfee00000
 
+/* constants relating to APIC ID registers */
+#define APIC_ID_MASK		0xff000000
+#define	APIC_ID_SHIFT		24
+#define	APIC_ID_CLUSTER		0xf0
+#define	APIC_ID_CLUSTER_ID	0x0f
+#define	APIC_MAX_CLUSTER	0xe
+#define	APIC_MAX_INTRACLUSTER_ID 3
+#define	APIC_ID_CLUSTER_SHIFT	4
+
 /* fields in VER */
 #define APIC_VER_VERSION	0x000000ff
 #define APIC_VER_MAXLVT		0x00ff0000
 #define MAXLVTSHIFT		16
 
+/* fields in LDR */
+#define	APIC_LDR_RESERVED	0x00ffffff
+
+/* fields in DFR */
+#define	APIC_DFR_RESERVED	0x0fffffff
+#define	APIC_DFR_MODEL_MASK	0xf0000000
+#define	APIC_DFR_MODEL_FLAT	0xf0000000
+#define	APIC_DFR_MODEL_CLUSTER	0x00000000
+
 /* fields in SVR */
 #define APIC_SVR_VECTOR		0x000000ff
 #define APIC_SVR_VEC_PROG	0x000000f0
@@ -290,10 +308,6 @@
 
 #define	APIC_ICRLO_RESV_MASK	(APIC_RESV1_MASK | APIC_RESV2_MASK)
 
-/* fields in ICR_HIGH */
-#define APIC_ID_MASK		0xff000000
-#define	APIC_ID_SHIFT		24
-
 /* fields in LVT1/2 */
 #define APIC_LVT_VECTOR		0x000000ff
 #define APIC_LVT_DM		0x00000700
@@ -444,4 +458,4 @@
 
 #define IOART_INTVEC	0x000000ff	/* R/W: INTerrupt vector field */
 
-#endif /* _MACHINE_APIC_H_ */
+#endif /* _MACHINE_APICREG_H_ */
Index: i386/include/apicvar.h
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- i386/include/apicvar.h	Thu Oct 30 14:48:10 2003
***************
*** 0 ****
--- 1,165 ----
+ /*-
+  * Copyright (c) 2003 John Baldwin <jhb@FreeBSD.org>
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. Neither the name of the author nor the names of any co-contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $FreeBSD$
+  */
+ 
+ #ifndef _MACHINE_APICVAR_H_
+ #define _MACHINE_APICVAR_H_
+ 
+ /*
+  * Local && I/O APIC variable definitions.
+  */
+ 
+ /*
+  * Layout of local APIC interrupt vectors:
+  *
+  *	0xff (255)  +-------------+
+  *                  |             | 15 (Spurios Vector)
+  *	0xf0 (240)  +-------------+
+  *                  |             | 14 (Interprocessor Interrupts)
+  *	0xe0 (224)  +-------------+
+  *                  |             | 13 (Local Interrupt (LINT[01]))
+  *	0xd0 (208)  +-------------+
+  *                  |             | 12 (Local Timer and Error Interrupts)
+  *	0xc0 (192)  +-------------+
+  *                  |             | 11 (I/O Interrupts)
+  *	0xb0 (176)  +-------------+
+  *                  |             | 10 (I/O Interrupts)
+  *	0xa0 (160)  +-------------+
+  *                  |             | 9 (I/O Interrupts)
+  *	0x90 (144)  +-------------+
+  *                  |             | 8 (I/O Interrupts / System Calls)
+  *	0x80 (128)  +-------------+
+  *                  |             | 7 (I/O Interrupts)
+  *	0x70 (112)  +-------------+
+  *                  |             | 6 (I/O Interrupts)
+  *	0x60 (96)   +-------------+
+  *                  |             | 5 (I/O Interrupts)
+  *	0x50 (80)   +-------------+
+  *                  |             | 4 (I/O Interrupts)
+  *	0x40 (64)   +-------------+
+  *                  |             | 3 (I/O Interrupts)
+  *	0x30 (48)   +-------------+
+  *                  |             | 2 (I/O Interrupts)
+  *	0x20 (32)   +-------------+
+  *                  |             | 1 (Exceptions, traps, faults, etc.)
+  *	0x10 (16)   +-------------+
+  *                  |             | 0 (Exceptions, traps, faults, etc.)
+  *	0x00 (0)    +-------------+
+  *
+  * Note: 0x80 needs to be handled specially and not allocated to an
+  * I/O device!
+  */
+ 
+ #define	APIC_ID_ALL	0xff
+ #define	APIC_NUM_IOINTS	160
+ 
+ #define	APIC_LOCAL_INTS	(IDT_IO_INTS + APIC_NUM_IOINTS)
+ #define	APIC_TIMER_INT	APIC_LOCAL_INTS
+ #define	APIC_ERROR_INT	(APIC_LOCAL_INTS + 1)
+ #define	APIC_THERMAL_INT (APIC_LOCAL_INTS + 2)
+ 
+ #define	APIC_IPI_INTS	(APIC_LOCAL_INTS + 32)
+ #define	IPI_AST		APIC_IPI_INTS		/* Generate software trap. */
+ #define	IPI_INVLTLB	(APIC_IPI_INTS + 1)	/* TLB Shootdown IPIs */
+ #define	IPI_INVLPG	(APIC_IPI_INTS + 2)
+ #define	IPI_INVLRNG	(APIC_IPI_INTS + 3)
+ #define	IPI_HARDCLOCK	(APIC_IPI_INTS + 8)	/* Inter-CPU clock handling. */
+ #define	IPI_STATCLOCK	(APIC_IPI_INTS + 9)
+ #define	IPI_RENDEZVOUS	(APIC_IPI_INTS + 10)	/* Inter-CPU rendezvous. */
+ #define	IPI_LAZYPMAP	(APIC_IPI_INTS + 11)	/* Lazy pmap release. */
+ #define	IPI_STOP	(APIC_IPI_INTS + 12)	/* Stop CPU until restarted. */
+ 
+ #define	APIC_SPURIOUS_INT 255
+ 
+ #define	LVT_LINT0	0
+ #define	LVT_LINT1	1
+ #define	LVT_TIMER	2
+ #define	LVT_ERROR	3
+ #define	LVT_PMC		4
+ #define	LVT_THERMAL	5
+ #define	LVT_MAX		LVT_THERMAL
+ 
+ #ifndef LOCORE
+ 
+ #define	APIC_IPI_DEST_SELF	-1
+ #define	APIC_IPI_DEST_ALL	-2
+ #define	APIC_IPI_DEST_OTHERS	-3
+ 
+ /*
+  * An APIC enumerator is a psuedo bus driver that enumerates APIC's including
+  * CPU's and I/O APIC's.
+  */
+ struct apic_enumerator {
+ 	const char *apic_name;
+ 	int (*apic_probe)(void);
+ 	int (*apic_probe_cpus)(void);
+ 	int (*apic_setup_local)(void);
+ 	int (*apic_setup_io)(void);
+ 	SLIST_ENTRY(apic_enumerator) apic_next;
+ };
+ 
+ inthand_t
+ 	IDTVEC(apic_isr1), IDTVEC(apic_isr2), IDTVEC(apic_isr3),
+ 	IDTVEC(apic_isr4), IDTVEC(apic_isr5), IDTVEC(spuriousint);
+ 
+ u_int	apic_irq_to_idt(u_int irq);
+ u_int	apic_idt_to_irq(u_int vector);
+ void	apic_register_enumerator(struct apic_enumerator *enumerator);
+ void	*ioapic_create(uintptr_t addr, int32_t id, int intbase);
+ int	ioapic_disable_pin(void *cookie, u_int pin);
+ int	ioapic_get_vector(void *cookie, u_int pin);
+ int	ioapic_next_logical_cluster(void);
+ void	ioapic_register(void *cookie);
+ int	ioapic_remap_vector(void *cookie, u_int pin, int vector);
+ int	ioapic_set_extint(void *cookie, u_int pin);
+ int	ioapic_set_nmi(void *cookie, u_int pin);
+ int	ioapic_set_polarity(void *cookie, u_int pin, char activehi);
+ int	ioapic_set_triggermode(void *cookie, u_int pin, char edgetrigger);
+ int	ioapic_set_smi(void *cookie, u_int pin);
+ void	lapic_create(u_int apic_id, int boot_cpu);
+ void	lapic_disable(void);
+ void	lapic_dump(const char *str);
+ void	lapic_enable_intr(u_int vector);
+ int	lapic_id(void);
+ void	lapic_init(uintptr_t addr);
+ int	lapic_intr_pending(u_int vector);
+ void	lapic_ipi_raw(register_t icrlo, u_int dest);
+ void	lapic_ipi_vectored(u_int vector, int dest);
+ int	lapic_ipi_wait(int delay);
+ void	lapic_handle_intr(struct intrframe frame);
+ void	lapic_set_logical_id(u_int apic_id, u_int cluster, u_int cluster_id);
+ int	lapic_set_lvt_mask(u_int apic_id, u_int lvt, u_char masked);
+ int	lapic_set_lvt_mode(u_int apic_id, u_int lvt, u_int32_t mode);
+ int	lapic_set_lvt_polarity(u_int apic_id, u_int lvt, u_char activehi);
+ int	lapic_set_lvt_triggermode(u_int apic_id, u_int lvt, u_char edgetrigger);
+ void	lapic_setup(void);
+ 
+ #endif /* !LOCORE */
+ #endif /* _MACHINE_APICVAR_H_ */
Index: i386/include/asmacros.h
===========================================================================
--- sys/i386/include/asmacros.h	2003/10/30 14:48:07	#3
+++ i386/include/asmacros.h	2003/10/30 14:48:07
@@ -138,4 +138,15 @@
 #define MEXITCOUNT
 #endif /* GPROF */
 
+#ifdef LOCORE
+/*
+ * Convenience macros for declaring interrupt entry points and trap
+ * stubs.
+ */
+#define	IDTVEC(name)	ALIGN_TEXT; .globl __CONCAT(X,name); \
+			.type __CONCAT(X,name),@function; __CONCAT(X,name):
+#define	TRAP(a)		pushl $(a) ; jmp alltraps
+
+#endif /* LOCORE */
+
 #endif /* !_MACHINE_ASMACROS_H_ */
Index: i386/include/clock.h
===========================================================================
--- sys/i386/include/clock.h	2003/10/30 14:48:07	#9
+++ i386/include/clock.h	2003/10/30 14:48:07
@@ -24,9 +24,6 @@
 extern uint64_t	tsc_freq;
 extern int	tsc_is_broken;
 extern int	wall_cmos_clock;
-#ifdef APIC_IO
-extern int	apic_8254_intr;
-#endif
 
 /*
  * Driver to clock driver interface.
Index: i386/include/critical.h
===========================================================================
--- sys/i386/include/critical.h	2003/10/30 14:48:07	#4
+++ i386/include/critical.h	2003/10/30 14:48:07
@@ -44,7 +44,6 @@
 /*
  * Prototypes - see <arch>/<arch>/critical.c
  */
-void cpu_unpend(void);
 void cpu_critical_fork_exit(void);
 
 #ifdef	__GNUC__
@@ -59,7 +58,11 @@
  *	However, as a side effect any interrupts occuring while td_critnest
  *	is non-zero will be deferred.
  */
-#define cpu_critical_enter()
+static __inline void
+cpu_critical_enter(void)
+{
+	curthread->td_md.md_savecrit = intr_disable();
+}
 
 /*
  *	cpu_critical_exit:
@@ -75,19 +78,7 @@
 static __inline void
 cpu_critical_exit(void)
 {
-	/*
-	 * We may have to schedule pending interrupts.  Create
-	 * conditions similar to an interrupt context and call
-	 * unpend().
-	 *
-	 * note: we do this even if we are in an interrupt
-	 * nesting level.  Deep nesting is protected by
-	 * critical_*() and if we conditionalized it then we
-	 * would have to check int_pending again whenever
-	 * we decrement td_intr_nesting_level to 0.
-	 */
-	if (PCPU_GET(int_pending))
-		cpu_unpend();
+	intr_restore(curthread->td_md.md_savecrit);
 }
 
 #else /* !__GNUC__ */
Index: i386/include/intr_machdep.h
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- i386/include/intr_machdep.h	Thu Oct 30 14:48:10 2003
***************
*** 0 ****
--- 1,91 ----
+ /*-
+  * Copyright (c) 2003 John Baldwin <jhb@FreeBSD.org>
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $FreeBSD$
+  */
+ 
+ #ifndef __MACHINE_INTR_MACHDEP_H__
+ #define	__MACHINE_INTR_MACHDEP_H__
+ 
+ #ifdef _KERNEL
+ 
+ /* With I/O APIC's we can have up to 159 interrupts. */
+ #define	NUM_IO_INTS	159
+ #define	INTRCNT_COUNT	(1 + NUM_IO_INTS * 2)
+ 
+ #ifndef LOCORE
+ 
+ typedef void inthand_t(u_int cs, u_int ef, u_int esp, u_int ss);
+ 
+ #define	IDTVEC(name)	__CONCAT(X,name)
+ 
+ struct intsrc;
+ 
+ /*
+  * Methods that a PIC provides to mask/unmask a given interrupt source,
+  * "turn on" the interrupt on the CPU side by setting up an IDT entry, and
+  * return the vector associated with this source.
+  */
+ struct pic {
+ 	void (*pic_enable_source)(struct intsrc *);
+ 	void (*pic_disable_source)(struct intsrc *);
+ 	void (*pic_eoi_source)(struct intsrc *);
+ 	void (*pic_enable_intr)(struct intsrc *);
+ 	int (*pic_vector)(struct intsrc *);
+ 	int (*pic_source_pending)(struct intsrc *);
+ 	void (*pic_suspend)(struct intsrc *);
+ 	void (*pic_resume)(struct intsrc *);
+ };
+ 
+ /*
+  * An interrupt source.  The upper-layer code uses the PIC methods to
+  * control a given source.  The lower-layer PIC drivers can store additional
+  * private data in a given interrupt source such as an interrupt pin number
+  * or an I/O APIC pointer.
+  */
+ struct intsrc {
+ 	struct pic *is_pic;
+ 	struct ithd *is_ithread;
+ 	u_long *is_count;
+ 	u_long *is_straycount;
+ 	u_int is_index;
+ };
+ 
+ struct intrframe;
+ 
+ extern struct mtx icu_lock;
+ 
+ int	intr_add_handler(const char *name, int vector, driver_intr_t handler,
+     void *arg, enum intr_type flags, void **cookiep);
+ void	intr_execute_handlers(struct intsrc *isrc, struct intrframe *iframe);
+ struct intsrc *intr_lookup_source(int vector);
+ int	intr_register_source(struct intsrc *isrc);
+ int	intr_remove_handler(void *cookie);
+ void	intr_resume(void);
+ void	intr_suspend(void);
+ 
+ #endif	/* !LOCORE */
+ #endif	/* _KERNEL */
+ #endif	/* !__MACHINE_INTR_MACHDEP_H__ */
Index: i386/include/md_var.h
===========================================================================
--- sys/i386/include/md_var.h	2003/10/30 14:48:07	#26
+++ i386/include/md_var.h	2003/10/30 14:48:07
@@ -43,6 +43,7 @@
 
 extern	long	Maxmem;
 extern	u_int	atdevbase;	/* offset in virtual memory of ISA io mem */
+extern	u_int	basemem;	/* PA of original top of base memory */
 extern	int	busdma_swi_pending;
 extern	u_int	cpu_exthigh;
 extern	u_int	cpu_feature;
@@ -96,6 +97,7 @@
 void	sse2_pagezero(void *addr);
 void	init_AMD_Elan_sc520(void);
 int	is_physical_memory(vm_offset_t addr);
+int	isa_nmi(int cd);
 vm_paddr_t kvtop(void *addr);
 void	setidt(int idx, alias_for_inthand_t *func, int typ, int dpl, int selec);
 int     user_dbreg_trap(void);
Index: i386/include/mpapic.h
===========================================================================
--- sys/i386/include/mpapic.h	2003/10/30 14:48:07	#1
+++ i386/include/mpapic.h	2003/10/30 14:48:07
@@ -28,6 +28,8 @@
 #ifndef _MACHINE_MPAPIC_H_
 #define _MACHINE_MPAPIC_H_
 
+#error	Don't use this header
+
 /*
  * Size of APIC ID list.
  * Also used a MAX size of various other arrays.
Index: i386/include/mptable.h
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- i386/include/mptable.h	Thu Oct 30 14:48:10 2003
***************
*** 0 ****
--- 1,145 ----
+ /*
+  * Copyright (c) 1996, by Steve Passe
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. The name of the developer may NOT be used to endorse or promote products
+  *    derived from this software without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $FreeBSD$
+  */
+ 
+ #ifndef __MACHINE_MPTABLE_H__
+ #define	__MACHINE_MPTABLE_H__
+ 
+ enum busTypes {
+     NOBUS = 0,
+     EISA = 3,
+     ISA = 6,
+     MCA = 9,
+     PCI = 13,
+     MAX_BUSTYPE = 18,
+     UNKNOWN_BUSTYPE = 0xff
+ };
+ 
+ /* MP Floating Pointer Structure */
+ typedef struct MPFPS {
+ 	char    signature[4];
+ 	void   *pap;
+ 	u_char  length;
+ 	u_char  spec_rev;
+ 	u_char  checksum;
+ 	u_char  config_type;
+ 	u_char  mpfb2;
+ 	u_char  mpfb3;
+ 	u_char  mpfb4;
+ 	u_char  mpfb5;
+ }      *mpfps_t;
+ 
+ #define	MPFB2_IMCR_PRESENT	0x80
+ #define	MPFB2_MUL_CLK_SRCS	0x40
+ 
+ /* MP Configuration Table Header */
+ typedef struct MPCTH {
+ 	char    signature[4];
+ 	u_short base_table_length;
+ 	u_char  spec_rev;
+ 	u_char  checksum;
+ 	u_char  oem_id[8];
+ 	u_char  product_id[12];
+ 	void   *oem_table_pointer;
+ 	u_short oem_table_size;
+ 	u_short entry_count;
+ 	void   *apic_address;
+ 	u_short extended_table_length;
+ 	u_char  extended_table_checksum;
+ 	u_char  reserved;
+ }      *mpcth_t;
+ 
+ #define	MPCT_ENTRY_PROCESSOR	0
+ #define	MPCT_ENTRY_BUS		1
+ #define	MPCT_ENTRY_IOAPIC	2
+ #define	MPCT_ENTRY_INT		3
+ #define	MPCT_ENTRY_LOCAL_INT	4
+ 
+ typedef struct PROCENTRY {
+ 	u_char  type;
+ 	u_char  apic_id;
+ 	u_char  apic_version;
+ 	u_char  cpu_flags;
+ 	u_long  cpu_signature;
+ 	u_long  feature_flags;
+ 	u_long  reserved1;
+ 	u_long  reserved2;
+ }      *proc_entry_ptr;
+ 
+ #define PROCENTRY_FLAG_EN	0x01
+ #define PROCENTRY_FLAG_BP	0x02
+ 
+ typedef struct BUSENTRY {
+ 	u_char  type;
+ 	u_char  bus_id;
+ 	char    bus_type[6];
+ }      *bus_entry_ptr;
+ 
+ typedef struct IOAPICENTRY {
+ 	u_char  type;
+ 	u_char  apic_id;
+ 	u_char  apic_version;
+ 	u_char  apic_flags;
+ 	void   *apic_address;
+ }      *io_apic_entry_ptr;
+ 
+ #define IOAPICENTRY_FLAG_EN	0x01
+ 
+ typedef struct INTENTRY {
+ 	u_char  type;
+ 	u_char  int_type;
+ 	u_short int_flags;
+ 	u_char  src_bus_id;
+ 	u_char  src_bus_irq;
+ 	u_char  dst_apic_id;
+ 	u_char  dst_apic_int;
+ }      *int_entry_ptr;
+ 
+ #define	INTENTRY_TYPE_INT  	0
+ #define	INTENTRY_TYPE_NMI	1
+ #define	INTENTRY_TYPE_SMI	2
+ #define	INTENTRY_TYPE_EXTINT	3
+ 
+ #define	INTENTRY_FLAGS_POLARITY			0x3
+ #define	INTENTRY_FLAGS_POLARITY_CONFORM		0x0
+ #define	INTENTRY_FLAGS_POLARITY_ACTIVEHI	0x1
+ #define	INTENTRY_FLAGS_POLARITY_ACTIVELO	0x3
+ #define	INTENTRY_FLAGS_TRIGGER			0xc
+ #define	INTENTRY_FLAGS_TRIGGER_CONFORM		0x0
+ #define	INTENTRY_FLAGS_TRIGGER_EDGE		0x4
+ #define	INTENTRY_FLAGS_TRIGGER_LEVEL		0xc
+ 
+ /* descriptions of MP basetable entries */
+ typedef struct BASETABLE_ENTRY {
+ 	u_char  type;
+ 	u_char  length;
+ 	char    name[16];
+ }       basetable_entry;
+ 
+ int	mptable_pci_probe_table(int bus);
+ int	mptable_pci_route_interrupt(device_t pcib, device_t dev, int pin);
+ 
+ #endif /* !__MACHINE_MPTABLE_H__ */
Index: i386/include/pcpu.h
===========================================================================
--- sys/i386/include/pcpu.h	2003/10/30 14:48:07	#7
+++ i386/include/pcpu.h	2003/10/30 14:48:07
@@ -48,10 +48,7 @@
 	struct	segment_descriptor pc_common_tssd;			\
 	struct	segment_descriptor *pc_tss_gdt;				\
 	int	pc_currentldt;						\
-	u_int32_t pc_int_pending;	/* master int pending flag */   \
-	u_int32_t pc_ipending;	/* pending slow interrupts */		\
-	u_int32_t pc_fpending;	/* pending fast interrupts */		\
-	u_int32_t pc_spending 	/* pending soft interrupts */
+	u_int	pc_apic_id;
 
 #if defined(lint)
  
Index: i386/include/proc.h
===========================================================================
--- sys/i386/include/proc.h	2003/10/30 14:48:07	#9
+++ i386/include/proc.h	2003/10/30 14:48:07
@@ -51,9 +51,7 @@
  * Machine-dependent part of the proc structure for i386.
  */
 struct mdthread {
-#ifdef lint
-	int	dummy;
-#endif
+	register_t md_savecrit;
 };
 
 struct mdproc {
Index: i386/include/segments.h
===========================================================================
--- sys/i386/include/segments.h	2003/10/30 14:48:07	#10
+++ i386/include/segments.h	2003/10/30 14:48:07
@@ -173,11 +173,7 @@
  * Size of IDT table
  */
 
-#if defined(SMP) || defined(APIC_IO)
-#define	NIDT	256		/* we use them all */
-#else
-#define	NIDT	129		/* 32 reserved, 16 h/w, 0 s/w, linux's 0x80 */
-#endif /* SMP || APIC_IO */
+#define	NIDT	256		/* 32 reserved, 0x80 syscall, most are h/w */
 #define	NRSVIDT	32		/* reserved entries for cpu exceptions */
 
 /*
@@ -202,6 +198,7 @@
 #define	IDT_AC		17	/* #AC: Alignment Check */
 #define	IDT_MC		18	/* #MC: Machine Check */
 #define	IDT_XF		19	/* #XF: SIMD Floating-Point Exception */
+#define	IDT_IO_INTS	NRSVIDT	/* Base of IDT entries for I/O interrupts. */
 #define	IDT_SYSCALL	0x80	/* System Call Interrupt Vector */
 
 /*
